<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_PriceRange StructType
 * @subpackage Structs
 */
class JP_PriceRange extends AbstractStructBase
{
    /**
     * The Minimum
     * Meta information extracted from the WSDL
     * - use: required
     * @var float
     */
    public $Minimum;
    /**
     * The Maximum
     * Meta information extracted from the WSDL
     * - use: required
     * @var float
     */
    public $Maximum;
    /**
     * The Currency
     * @var string
     */
    public $Currency;
    /**
     * Constructor method for JP_PriceRange
     * @uses JP_PriceRange::setMinimum()
     * @uses JP_PriceRange::setMaximum()
     * @uses JP_PriceRange::setCurrency()
     * @param float $minimum
     * @param float $maximum
     * @param string $currency
     */
    public function __construct($minimum = null, $maximum = null, $currency = null)
    {
        $this
            ->setMinimum($minimum)
            ->setMaximum($maximum)
            ->setCurrency($currency);
    }
    /**
     * Get Minimum value
     * @return float
     */
    public function getMinimum()
    {
        return $this->Minimum;
    }
    /**
     * Set Minimum value
     * @param float $minimum
     * @return \StructType\JP_PriceRange
     */
    public function setMinimum($minimum = null)
    {
        // validation for constraint: float
        if (!is_null($minimum) && !(is_float($minimum) || is_numeric($minimum))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($minimum, true), gettype($minimum)), __LINE__);
        }
        $this->Minimum = $minimum;
        return $this;
    }
    /**
     * Get Maximum value
     * @return float
     */
    public function getMaximum()
    {
        return $this->Maximum;
    }
    /**
     * Set Maximum value
     * @param float $maximum
     * @return \StructType\JP_PriceRange
     */
    public function setMaximum($maximum = null)
    {
        // validation for constraint: float
        if (!is_null($maximum) && !(is_float($maximum) || is_numeric($maximum))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($maximum, true), gettype($maximum)), __LINE__);
        }
        $this->Maximum = $maximum;
        return $this;
    }
    /**
     * Get Currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->Currency;
    }
    /**
     * Set Currency value
     * @param string $currency
     * @return \StructType\JP_PriceRange
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        $this->Currency = $currency;
        return $this;
    }
}
